#ifndef SEARCH_H
#define SEARCH_H

#include "halton.h"
#include "pointset.h"
#include <string>

class search {
  public:
    search(int npoints, int dim, int *ps);

    // return best discrepancy, write result in file filename
    double run(int iterations);
    virtual void _run(int iterations) = 0;

  protected:
    void check();

    int dim, npoints;
    double best;
    std::string filename;
    halton ha;
    pointset ps;
};

class random_search: public search {
  public:
    random_search(int dim, int npoints, int *p);
    virtual void _run(int iterations);
};

#endif // SEARCH_H
